<?php

namespace GQ_\Arrays;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGroupDataAirport Arrays
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGroupDataAirport
 * @package GQ_
 * @subpackage Arrays
 */
class GQ_ArrayOfGroupDataAirport extends AbstractStructArrayBase
{
    /**
     * The GroupDataAirport
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \GQ_\Structs\GQ_GroupDataAirport[]
     */
    public $GroupDataAirport;
    /**
     * Constructor method for ArrayOfGroupDataAirport
     * @uses GQ_ArrayOfGroupDataAirport::setGroupDataAirport()
     * @param \GQ_\Structs\GQ_GroupDataAirport[] $groupDataAirport
     */
    public function __construct(array $groupDataAirport = array())
    {
        $this
            ->setGroupDataAirport($groupDataAirport);
    }
    /**
     * Get GroupDataAirport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \GQ_\Structs\GQ_GroupDataAirport[]|null
     */
    public function getGroupDataAirport()
    {
        return isset($this->GroupDataAirport) ? $this->GroupDataAirport : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGroupDataAirport method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGroupDataAirport method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGroupDataAirportForArrayConstraintsFromSetGroupDataAirport(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGroupDataAirportGroupDataAirportItem) {
            // validation for constraint: itemType
            if (!$arrayOfGroupDataAirportGroupDataAirportItem instanceof \GQ_\Structs\GQ_GroupDataAirport) {
                $invalidValues[] = is_object($arrayOfGroupDataAirportGroupDataAirportItem) ? get_class($arrayOfGroupDataAirportGroupDataAirportItem) : sprintf('%s(%s)', gettype($arrayOfGroupDataAirportGroupDataAirportItem), var_export($arrayOfGroupDataAirportGroupDataAirportItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GroupDataAirport property can only contain items of type \GQ_\Structs\GQ_GroupDataAirport, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GroupDataAirport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \GQ_\Structs\GQ_GroupDataAirport[] $groupDataAirport
     * @return \GQ_\Arrays\GQ_ArrayOfGroupDataAirport
     */
    public function setGroupDataAirport(array $groupDataAirport = array())
    {
        // validation for constraint: array
        if ('' !== ($groupDataAirportArrayErrorMessage = self::validateGroupDataAirportForArrayConstraintsFromSetGroupDataAirport($groupDataAirport))) {
            throw new \InvalidArgumentException($groupDataAirportArrayErrorMessage, __LINE__);
        }
        if (is_null($groupDataAirport) || (is_array($groupDataAirport) && empty($groupDataAirport))) {
            unset($this->GroupDataAirport);
        } else {
            $this->GroupDataAirport = $groupDataAirport;
        }
        return $this;
    }
    /**
     * Add item to GroupDataAirport value
     * @throws \InvalidArgumentException
     * @param \GQ_\Structs\GQ_GroupDataAirport $item
     * @return \GQ_\Arrays\GQ_ArrayOfGroupDataAirport
     */
    public function addToGroupDataAirport(\GQ_\Structs\GQ_GroupDataAirport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \GQ_\Structs\GQ_GroupDataAirport) {
            throw new \InvalidArgumentException(sprintf('The GroupDataAirport property can only contain items of type \GQ_\Structs\GQ_GroupDataAirport, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GroupDataAirport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \GQ_\Structs\GQ_GroupDataAirport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \GQ_\Structs\GQ_GroupDataAirport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \GQ_\Structs\GQ_GroupDataAirport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \GQ_\Structs\GQ_GroupDataAirport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \GQ_\Structs\GQ_GroupDataAirport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GroupDataAirport
     */
    public function getAttributeName()
    {
        return 'GroupDataAirport';
    }
}
